Std Créer un lien

From FreeCAD Documentation
Revision as of 19:07, 11 September 2020 by FuzzyBot (talk | contribs) (Updating to match new version of source page)

Std LinkMake

Emplacement du menu
Aucun
Ateliers
Tous
Raccourci par défaut
Aucun
Introduit dans la version
0.19
Voir aussi
Std Part, Std Groupe, PartDesign Corps

Description

Std LinkMake crée un App Link (App::Link class), type d'objet qui fait référence à un autre objet dans le même document ou dans un autre document. Il est destiné à être utilisé dans des ensembles mécaniques dans lesquels un même objet peut apparaître plusieurs fois, par exemple des vis et des boulons, mais également d'autres sous-ensembles complexes.

Pour une duplication simple des objets, voir Draft Clone, Draft Matrice et Draft Série de copies. Les outils Draft LinkArray et Draft PathLinkArray créent des liens au lieu de simples copies.

Les liens sont destinés à être utilisés avec des corps entiers. Pour créer des tableaux de caractéristiques dans le même PartDesign Corps, utilisez PartDesign Répétition linéaire, PartDesign Répétition circulaire et PartDesign Transformation multiple.

The Std LinkMake tool is not defined by a particular workbench, but by the base system, thus it is found in the structure toolbar that is available in all workbenches. The Link object, used in conjunction with Std Part to group various objects, forms the basis of the Assembly3 and Assembly4 Workbenches.

Utilisation

  1. Sélectionnez un objet pour lequel vous souhaitez créer un lien.
  2. Appuyez sur le bouton Std LinkMake. Si aucun objet n'est sélectionné, un lien vide sera créé.

Without selection:

  1. If no object is selected, press the Std LinkMake button to create an empty Link.
  2. Go to the property editor, then click on the DonnéesLinked Object property to open the Link selection dialog to choose an object, then press OK.
  3. Instead of choosing an entire object in the tree view, you can also pick subelements (vertices, edges, or faces) of a single object in the 3D view. In this case, the Link will duplicate only these subelements, and the arrow overlay will be different.

Propriétés

An App Link (App::Link class) is derived from the basic App DocumentObject (App::DocumentObject class), therefore it has the latter's basic properties like DonnéesLabel and DonnéesLabel2.

The following are the specific properties available in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Données

Link

  • DonnéesLinked Object:
  • DonnéesLink Transform:
  • DonnéesPlacement:
  • DonnéesSub Elements:
  • DonnéesShow Elements:
  • DonnéesElement Count:
  • DonnéesScale:

Base

  • Données (Hidden)Proxy (PythonObject): a custom class associated with this object. This only exists for the Python version. See Scripting.

De plus, il affichera les propriétés de l'original DonnéesLinked Object.

Vues

Link

  • VueDraw Style:
  • VueLine Width:
  • VueOverride Material:
  • VuePoint Size:
  • VueSelectable:
  • VueShape Material:
  • VueShape Material (Material): this property includes sub-properties that describe the appearance of the object.
    • VueDiffuse Color, it defaults to (0.4, 1.0, 1.0), which is displayed as [102, 255, 255] on base 255, light blue .
    • VueAmbient Color, it defaults to (0.2, 0.2, 0.2), which is displayed as [51, 51, 51] on base 255, dark gray .
    • VueSpecular Color, it defaults to (0.0, 0.0, 0.0), which is displayed as [0, 0, 0] on base 255, black .
    • VueEmissive Color, it defaults to (0.0, 0.0, 0.0), which is displayed as [0, 0, 0] on base 255, black .
    • VueShininess, it defaults to 0.2
    • VueTransparency, it defaults to 0.0.

Base

  • Vue (Hidden)Child View Provider (PersistentObject):
  • Vue (Hidden)Material List (MaterialList): (read-only) if individual materials have been added, they will be listed here.
  • Vue (Hidden)Override Color List (ColorList): (read-only) if the individual faces or edges of the link have been overridden they will be listed here.
  • Vue (Hidden)Override Material List (BoolList): (read-only) if the individual materials of the link have been overridden they will be listed here.

Display Options

  • VueDisplay Mode (Enumeration): 'Link' or 'ChildView'.
  • VueShow In Tree (Bool): see the information in App FeaturePython.
  • VueVisibility (Bool): see the information in App FeaturePython.

Selection

Il montrera en outre les propriétés de vue de l'original DonnéesLinked Object.

Inheritance

An App Link is formally an instance of the class App::Link, whose parent is the basic App DocumentObject (App::DocumentObject class). It is a very low level object, which can be used with most other document objects.

Simplified diagram of the relationships between the core objects in the program. The App::Link object is a core component of the system, it does not depend on any workbench, but it can be used with most objects created in all workbenches.

Scripting

See also: FreeCAD Scripting Basics, and scripted objects.

See Part Feature for the general information.

An App Link is created with the addObject() method of the document. It can define its DonnéesLinked Object by overriding its LinkedObject attribute, or by using its setLink method.

import FreeCAD as App

doc = App.newDocument()
bod1 = App.ActiveDocument.addObject("PartDesign::Body", "Body")
bod2 = App.ActiveDocument.addObject("Part::Box", "Box")

obj1 = App.ActiveDocument.addObject("App::Link", "Link")
obj2 = App.ActiveDocument.addObject("App::Link", "Link")

obj1.LinkedObject = bod1
obj2.setLink(bod2)
App.ActiveDocument.recompute()

The basic App::Link doesn't have a Proxy object so it can't be fully used for sub-classing.

Therefore, for Python subclassing, you should create the App::LinkPython object.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("App::LinkPython", "Link")
obj.Label = "Custom label"

Further reading

The App Link object was introduced after 2 years of development and prototyping. This component was thought and developed almost single-handedly by user realthunder. The motivations and design implementations behind this project are described in his GitHub page, Link. In order to accomplish this feature, several core changes to FreeCAD were made; these were also extensively documented in Core-Changes.

The App Link project started after the redesign of the PartDesign Workbench was complete in v0.17. The history of App Link can be traced to some essential forum threads:

Finally, the pull request and merge happened: